'use strict';

import React from "react";
import PropTypes from "prop-types";

class TypeaheadResultList extends React.Component {

    constructor(props) {
        super(props);
    }

    render() {
        let listCls = this.props.options.length < 21 ? 'autocomplete-results' : 'autocomplete-results extended';
        if (this.props.customClasses.results) {
            listCls += ' ' + this.props.customClasses.results;
        }
        const items = [];
        for (let i = 0, len = this.props.options.length; i < len; i++) {
            // Explicitly bind the current option to the handler
            const onClick = this._onClick.bind(this, this.props.options[i]);
            items.push(<li className='btn-link item' key={'typeahead-result-' + i}
                           onClick={onClick}>{this._getOptionLabel(this.props.options[i])}</li>);
        }
        return <ul className={listCls}>
                {items}
            </ul>;
    }

    _getOptionLabel(option) {
        if (typeof this.props.displayOption === 'function') {
            return this.props.displayOption(option);
        } else {
            return option[this.props.displayOption];
        }
    }

    _onClick(option, event) {
        event.preventDefault();
        this.props.onOptionSelected(option);
    };
}

TypeaheadResultList.propTypes = {
    onOptionSelected: PropTypes.func.isRequired,
    options: PropTypes.array,
    displayOption: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
    customClasses: PropTypes.object
};

export default TypeaheadResultList;
