export default class ReportValidator {

    /**
     * Checks whether the specified report contains valid values.
     * @param report The report to validate
     * @return {boolean} true if the report is valid, false otherwise
     */
    static isValid(report) {
        if (!report || !report.occurrence) {
            return false;
        }
        const occurrence = report.occurrence;
        if (!occurrence.name || occurrence.name.length === 0) {
            return false;
        }
        if (!occurrence.startTime || !occurrence.endTime) {
            return false;
        }
        if (!occurrence.severity || !occurrence.type) {
            return false;
        }
        return true;
    }
}